--- icu4c/source/data/brkitr/ja.txt
+++ icu4c/source/data/brkitr/ja.txt
@@ -12,4 +12,64 @@ ja{
         line_strict:process(dependency){"line_cj.brk"}
         line_strict_phrase:process(dependency){"line_phrase_cj.brk"}
     }
+    extensions{
+        // Extensions.
+        // Entries in cjdict.txt categorized as particles (助詞), auxiliary verbs (助動詞),
+        // conjugations (活用)  and prefix of them.
+        // These entries are connected to the previous words for phrase based line breaking.
+        // https://ja.wikipedia.org/wiki/助詞
+        // https://ja.wikipedia.org/wiki/助動詞_(国文法)
+        // https://ja.wikipedia.org/wiki/活用
+        かい, かしら, から, きり, くらい,
+        ぐらい, けれど, けれども, こそ, さえ,
+        しか, した, ずつ, せる, せん,
+        たい, たがる, たく, たら, たり,
+        だけ, だに, だの, だり, つつ,
+        てる, です, でも, ところが, ところで,
+        とも, ない, なか, ながら, なく,
+        なし, なぞ, など, なら, なり,
+        なんぞ, ねる, ので, のに, のみ,
+        ばかり, へる, ほど, まい, まう,
+        まし, ます, まっ, まで, まま,
+        もん, やら, よう, より, らしい,
+        られる, れる, ろう, わっ, わな,
+        わら, わり, わる, われ, わん,
+
+        // Entries added for technical reasons (particle + others).
+        // Entries in cjdict.txt, which are compound words starting from the above categories
+        // (i.e. particles, auxiliary verbs and conjunctions).
+        // These entries are connected to the previous words for phrase based line breaking.
+        えたい, えて, える, けた, けたい,
+        ける, させる, そうだ, っきゃ, っきり,
+        っけ, っす, ったらしい, っちゅう, って,
+        っていう, ってか, ってな, っと, っぱなし,
+        っぷり, っぽい, にあう, にあがる, にあたって,
+        にあたり, にあたりまして, にあたります, にあたる, において,
+        におきまして, における, にかけ, にかけて, にかけまして,
+        にたいして, にたいしまして, にたいします, にたいする, について,
+        につき, につきまして, につけ, につれ, につれて,
+        にて, にとって, にとり, にとりまして, にまつわります,
+        にまつわる, にもかかわらず, にゃ, によって, により,
+        によりまして, によります, による, にわたって, にわたり,
+        にわたりまして, にわたります, にわたる, に対し, に対して,
+        に対しまして, に対します, に対する, に当たって, に当たり,
+        に当たりまして, に当たります, に当たる, に従い, に従いまして,
+        に従います, に従う, に従って, に関し, に関して,
+        に関しまして, に関します, に関する, に際し, に際して,
+        ものの, ろうし, ろうと, われと, をの,
+        をめぐって, をめぐりまして, をめぐります, をめぐる, をもちまして,
+        をもって, を以て, を通して, を通しまして, を通じ,
+        を通じて, を通じまして, んじゃ, んで,
+
+        // Entries added for technical reasons (noun suffix).
+        // Entries in cjdict.txt, which are suffixes of nouns.
+        // These entries should be connected to the previous (noun) words.
+        々宮, 々家, え目, が丘, が台,
+        が床, が浜, ヵ国, ヵ年, ヵ所,
+        ヵ月, ヵ村, ヵ条, ヶ丘, ヶ国,
+        ヶ島, ヶ年, ヶ所, ヶ月, ヶ村,
+        ヶ条, ージ, ーズ, ータ, ード,
+        ーニャ, ープランス, ーユ, ーランド, ーリンズ,
+        ーン,
+    }
 }
